package com.genuitec.hibernate;

import org.hibernate.HibernateException;
import org.hibernate.Session;
import org.hibernate.Transaction;

public class HibernateWriteTest {
	public static void main(String[] args) {
		// Step 1 - Create the DAO
		EchoMessageDAO dao = new EchoMessageDAO();
		// Step 2 - Create a new entity
		EchoMessage message = new EchoMessage(new Long(3));
		// Step 3 - Set the message field
		message.setMsg("Hello Hibernate, from MyEclipse!");

		Transaction tx = null;
		try {
			// Step 4 - Get a Hibernate Session
			Session session = dao.getSession();			
			tx = session.beginTransaction();
			// Step 5 - Save the entity
			dao.save(message);
			tx.commit();			
			System.out.println("Save successful.");
		} catch (HibernateException e) {
			tx.rollback();
			System.out.println("Save failed.");
			e.printStackTrace();
		} finally {
			try {
				dao.getSession().close();
			} catch (Exception e) {
				// do nothing
			}
		}
	}

}
